GnuRSAPrivateKey (GNU cryptographic primitives and tools)
Keywords: gnu.crypto.key.rsa.GnuRSAPrivateKey,GnuRSAPrivateKey class

Overview | Package | Class | Tree | Serialized | Deprecated | Index | Help
| For the latest news and information visit The GNU Crypto project
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## gnu.crypto.key.rsa
Class GnuRSAPrivateKey

    java.lang.Object
      |
      +--gnu.crypto.key.rsa.GnuRSAKey
            |
            +--gnu.crypto.key.rsa.GnuRSAPrivateKey

All Implemented Interfaces:
  java.security.Key, java.security.PrivateKey, java.security.interfaces.RSAKey, java.security.interfaces.RSAPrivateCrtKey, java.security.interfaces.RSAPrivateKey, java.io.Serializable

public class GnuRSAPrivateKey
extends GnuRSAKey
implements java.security.PrivateKey, java.security.interfaces.RSAPrivateCrtKey

An object that embodies an RSA private key.

References:

1. RSA-PSS Signature Scheme with Appendix, part B.
   Primitive specification and supporting documentation.
   Jakob Jonsson and Burt Kaliski.

See Also:
  Serialized Form

Field Summary

Fields inherited from interface java.security.PrivateKey
`serialVersionUID`

Constructor Summary
`GnuRSAPrivateKey(java.math.BigInteger p, java.math.BigInteger q, java.math.BigInteger e, java.math.BigInteger d)` Trivial constructor.

Method Summary
`boolean` | `equals(java.lang.Object obj)` Returns `true` if the designated object is an instance of this class and has the same RSA parameter values as this one.
`java.math.BigInteger` | `getCrtCoefficient()`
`byte[]` | `getEncoded(int format)` Returns the encoded form of this private key according to the designated format.
`java.math.BigInteger` | `getPrimeExponentP()`
`java.math.BigInteger` | `getPrimeExponentQ()`
`java.math.BigInteger` | `getPrimeP()`
`java.math.BigInteger` | `getPrimeQ()`
`java.math.BigInteger` | `getPrivateExponent()`
`static GnuRSAPrivateKey` | `valueOf(byte[] k)` A class method that takes the output of the `encodePrivateKey()` method of an RSA keypair codec object (an instance implementing `IKeyPairCodec` for RSA keys, and re-constructs an instance of this object.

Methods inherited from class gnu.crypto.key.rsa.GnuRSAKey
`getAlgorithm, getE, getEncoded, getFormat, getModulus, getN, getPublicExponent`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface java.security.Key
`getAlgorithm, getEncoded, getFormat`

Methods inherited from interface java.security.interfaces.RSAPrivateCrtKey
`getPublicExponent`

Methods inherited from interface java.security.interfaces.RSAKey
`getModulus`

Constructor Detail

### GnuRSAPrivateKey

    public GnuRSAPrivateKey(java.math.BigInteger p,
                            java.math.BigInteger q,
                            java.math.BigInteger e,
                            java.math.BigInteger d)

  Trivial constructor.

Parameters:
  `p` - the modulus first prime divisor.
  `q` - the modulus second prime divisor.
  `e` - the public exponent.
  `d` - the private exponent.

Method Detail

### valueOf

    public static GnuRSAPrivateKey valueOf(byte[] k)

  A class method that takes the output of the `encodePrivateKey()` method of an RSA keypair codec object (an instance implementing `IKeyPairCodec` for RSA keys, and re-constructs an instance of this object.

  Parameters:
    `k` - the contents of a previously encoded instance of this object.
  Throws:
    `java.lang.ArrayIndexOutOfBoundsException` - if there is not enough bytes, in `k`, to represent a valid encoding of an instance of this object.
    `java.lang.IllegalArgumentException` - if the byte sequence does not represent a valid encoding of an instance of this object.

### getPrimeP

    public java.math.BigInteger getPrimeP()

  Specified by:
    `getPrimeP` in interface `java.security.interfaces.RSAPrivateCrtKey`

### getPrimeQ

    public java.math.BigInteger getPrimeQ()

  Specified by:
    `getPrimeQ` in interface `java.security.interfaces.RSAPrivateCrtKey`

### getPrimeExponentP

    public java.math.BigInteger getPrimeExponentP()

  Specified by:
    `getPrimeExponentP` in interface `java.security.interfaces.RSAPrivateCrtKey`

### getPrimeExponentQ

    public java.math.BigInteger getPrimeExponentQ()

  Specified by:
    `getPrimeExponentQ` in interface `java.security.interfaces.RSAPrivateCrtKey`

### getCrtCoefficient

    public java.math.BigInteger getCrtCoefficient()

  Specified by:
    `getCrtCoefficient` in interface `java.security.interfaces.RSAPrivateCrtKey`

### getPrivateExponent

    public java.math.BigInteger getPrivateExponent()

  Specified by:
    `getPrivateExponent` in interface `java.security.interfaces.RSAPrivateKey`

### getEncoded

    public byte[] getEncoded(int format)

  Returns the encoded form of this private key according to the designated format.

  Specified by:
    `getEncoded` in class `GnuRSAKey`
  Parameters:
    `format` - the desired format identifier of the resulting encoding.
  Returns:
    the byte sequence encoding this key according to the designated format.
  Throws:
    `java.lang.IllegalArgumentException` - if the format is not supported.
  See Also:
    `RSAKeyPairRawCodec`

### equals

    public boolean equals(java.lang.Object obj)

  Returns `true` if the designated object is an instance of this class and has the same RSA parameter values as this one.

  Overrides:
    `equals` in class `GnuRSAKey`
  Parameters:
    `obj` - the other non-null RSA key to compare to.
  Returns:
    `true` if the designated object is of the same type and value as this one.

Overview | Package | Class | Tree | Serialized | Deprecated | Index | Help
| For the latest news and information visit The GNU Crypto project
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001, 2002, 2003, 2004 Free Software Foundation, Inc.